## adriconf-2.4.1-2.src.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.8)
project(adriconf)

set(CMAKE_CXX_STANDARD 14)

option(ENABLE_UNIT_TESTS "Enables building Unit tests" ON)
set(TOP_CMAKE_WAS_CALLED TRUE)

set(SYSCONFDIR "/etc" CACHE PATH "The path to read system-wide configuration. Equivalent to mesa SYSCONFDIR option")
add_definitions(-DSYSCONFDIR="${SYSCONFDIR}")

set(DATADIR "/usr/share/drirc.d" CACHE PATH "The path to read system-wide configurations. Equivalent to mesa DATADIR option")
add_definitions(-DDATADIR="${DATADIR}")

# Setup version string
if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
    execute_process(
        COMMAND git log -1 --format=%h
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
        OUTPUT_VARIABLE GIT_COMMIT_HASH
        OUTPUT_STRIP_TRAILING_WHITESPACE
    )
else()
    set(GIT_COMMIT_HASH "UNKNOWN")
endif()

file (STRINGS "VERSION" BUILD_VERSION_NUMBER)

configure_file(
        ${CMAKE_SOURCE_DIR}/adriconf/version.h.in
        ${CMAKE_BINARY_DIR}/generated/version.h
)

include_directories(${CMAKE_BINARY_DIR}/generated)

find_package(PkgConfig REQUIRED)
set(OpenGL_GL_PREFERENCE "GLVND")
find_package(OpenGL REQUIRED)

## ATKMM
pkg_check_modules(ATKMM atkmm-1.6)

# GTKMM
pkg_check_modules(GTKMM REQUIRED gtkmm-3.0)

# BOOST
find_package(Boost 1.60 REQUIRED COMPONENTS locale filesystem system)

# LIBXML
pkg_check_modules(LibXML++ libxml++-5.0)
if (NOT LibXML++_FOUND)
    pkg_check_modules(LibXML++3 libxml++-3.0)
    if (LibXML++3_FOUND)
        set(LibXML++_INCLUDE_DIRS ${LibXML++3_INCLUDE_DIRS})
        set(LibXML++_LIBRARIES ${LibXML++3_LIBRARIES})
    endif()
    if (NOT LibXML++3_FOUND)
        pkg_check_modules(LibXML++2 REQUIRED libxml++-2.6)
        set(LibXML++_INCLUDE_DIRS ${LibXML++2_INCLUDE_DIRS})
       set(LibXML++_LIBRARIES ${LibXML++2_LIBRARIES})
    endif ()
endif()

# X11
pkg_check_modules(X11 REQUIRED x11)

# LIBDRM
pkg_check_modules(DRM REQUIRED libdrm)

# GBM
pkg_check_modules(GBM REQUIRED gbm)

# LIBPCI
pkg_check_modules(PCILIB REQUIRED libpci)

# INTL
find_package(Intl REQUIRED)
find_package(Gettext REQUIRED)
include_directories(${INTL_INCLUDE_DIRS})
link_directories(${INTL_LIBRARY_DIRS})

#EGL
pkg_check_modules(EGL REQUIRED egl)

#INTL INSTALL TRANSLATIONS
GETTEXT_CREATE_TRANSLATIONS(po/adriconf.pot ALL po/en.po po/hr.po po/lv.po po/pl.po po/pt_BR.po po/zh_CN.po)

set(SHARED_SOURCE_FILES
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/Device.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/Device.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/DriverOption.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/DriverOption.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/Section.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/Section.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/DriverConfiguration.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/DriverConfiguration.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/GPUInfo.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/GPUInfo.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/Profile.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/Profile.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/ProfileOption.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/ProfileOption.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/ComboBoxColumn.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/DriverOptionType.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/GBMDevice.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/GBMDevice.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/EGLDisplayWrapper.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/EGLDisplayWrapper.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/DRMDeviceInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/DRMDevice.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/DRMDevice.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/ShadowProfile.h
        ${CMAKE_SOURCE_DIR}/adriconf/ValueObject/ShadowProfile.cpp

        ${CMAKE_SOURCE_DIR}/adriconf/Logging/LoggerInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/Logging/LoggerLevel.h

        ${CMAKE_SOURCE_DIR}/adriconf/Utils/ParserInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/ConfigurationResolverInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/DRIQuery.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/DRIQuery.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/WriterInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/ConfigurationLoaderInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/PCIDatabaseQuery.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/PCIDatabaseQuery.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/PCIDatabaseQueryInterface.h

        ${CMAKE_SOURCE_DIR}/adriconf/Utils/Parser.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/Parser.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/ConfigurationResolver.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/ConfigurationResolver.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/Writer.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/Writer.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/ConfigurationLoader.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/ConfigurationLoader.h

        ${CMAKE_SOURCE_DIR}/adriconf/Utils/GBMDeviceFactoryInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/GBMDeviceFactory.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/GBMDeviceFactory.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/EGLDisplayFactoryInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/EGLDisplayFactory.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/EGLDisplayFactory.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/DRMDeviceFactoryInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/DRMDeviceFactory.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/DRMDeviceFactory.h
        ${CMAKE_SOURCE_DIR}/adriconf/Translation/TranslatorInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/DisplayServerQueryInterface.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/WaylandQuery.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/WaylandQuery.h
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/XorgQuery.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Utils/XorgQuery.h

        ${CMAKE_SOURCE_DIR}/adriconf/CustomWidget/ComboBoxExtra.h
        ${CMAKE_SOURCE_DIR}/adriconf/CustomWidget/ExtraDataTreeModel.h
        ${CMAKE_SOURCE_DIR}/adriconf/CustomWidget/OptionSwitch.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/CustomWidget/OptionSwitch.h
        ${CMAKE_SOURCE_DIR}/adriconf/CustomWidget/OptionCombo.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/CustomWidget/OptionCombo.h
        ${CMAKE_SOURCE_DIR}/adriconf/CustomWidget/OptionSpin.h
        ${CMAKE_SOURCE_DIR}/adriconf/CustomWidget/OptionEntry.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/CustomWidget/OptionEntry.h

        ${CMAKE_SOURCE_DIR}/adriconf/GUI.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/GUI.h
        )

# GTest and GMock setup
if (ENABLE_UNIT_TESTS)
    configure_file(CMakeLists.txt.in googletest-download/CMakeLists.txt)
    execute_process(COMMAND "${CMAKE_COMMAND}" -G "${CMAKE_GENERATOR}" .
            WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download" )
    execute_process(COMMAND "${CMAKE_COMMAND}" --build .  WORKING_DIRECTORY "${CMAKE_BINARY_DIR}/googletest-download" )

    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)

    add_subdirectory("${CMAKE_BINARY_DIR}/googletest-src" "${CMAKE_BINARY_DIR}/googletest-build")
    add_subdirectory(tests)
endif()

add_subdirectory(adriconf)

=== adriconf/CMakeLists.txt ===
# Check if we are running from inside main config
if (NOT TOP_CMAKE_WAS_CALLED)
    message(FATAL_ERROR "
    You did not 'cmake' the top CMakeLists.txt file. Use the one in the top dir.
    It is advice to delete all wrongly generated cmake stuff => CMakeFiles & CMakeCache.txt")
endif ()

# Define the executable itself
add_executable(adriconf
        ${CMAKE_SOURCE_DIR}/adriconf/main.cpp
        ${SHARED_SOURCE_FILES}
        ${CMAKE_SOURCE_DIR}/adriconf/resources.c
        ${CMAKE_SOURCE_DIR}/adriconf/Logging/Logger.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Logging/Logger.h
        ${CMAKE_SOURCE_DIR}/adriconf/Translation/GetTextTranslator.cpp
        ${CMAKE_SOURCE_DIR}/adriconf/Translation/GetTextTranslator.h)

target_include_directories(adriconf PUBLIC ${ATKMM_INCLUDE_DIRS})

target_link_libraries(adriconf ${GTKMM_LIBRARIES})
target_include_directories(adriconf PUBLIC ${GTKMM_INCLUDE_DIRS})

target_link_libraries(adriconf ${Boost_LOCALE_LIBRARIES})
target_link_libraries(adriconf ${Boost_FILESYSTEM_LIBRARIES})
target_link_libraries(adriconf ${Boost_SYSTEM_LIBRARIES})
target_include_directories(adriconf PUBLIC ${Boost_INCLUDE_DIRS})

target_link_libraries(adriconf ${LibXML++_LIBRARIES})
target_include_directories(adriconf PUBLIC ${LibXML++_INCLUDE_DIRS})

target_link_libraries(adriconf ${X11_LIBRARIES})
target_include_directories(adriconf PUBLIC ${X11_INCLUDE_DIRS})

target_link_libraries(adriconf ${DRM_LIBRARIES})
target_include_directories(adriconf PUBLIC ${DRM_INCLUDE_DIRS})

target_link_libraries(adriconf ${GBM_LIBRARIES})
target_include_directories(adriconf PUBLIC ${GBM_INCLUDE_DIRS})

target_link_libraries(adriconf ${PCILIB_LIBRARIES})
target_include_directories(adriconf PUBLIC ${PCILIB_INCLUDE_DIRS})

target_link_libraries(adriconf ${OPENGL_gl_LIBRARY})
if (OpenGL_GLX_FOUND)
    target_link_libraries(adriconf ${OPENGL_glx_LIBRARY})
endif ()

target_link_libraries(adriconf ${EGL_LIBRARIES})
target_include_directories(adriconf PUBLIC ${EGL_INCLUDE_DIRS})

target_compile_options(adriconf PRIVATE -Wall -Wextra -pedantic)

add_custom_command(OUTPUT ${CMAKE_SOURCE_DIR}/adriconf/resources.c
        COMMAND glib-compile-resources ${CMAKE_SOURCE_DIR}/adriconf/adriconf.gresource.xml --target=resources.c --generate-source
        WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}/adriconf
        DEPENDS ${CMAKE_SOURCE_DIR}/adriconf/DriConf.glade ${CMAKE_SOURCE_DIR}/adriconf/DarkTheme.css
        COMMENT "Generate resources"
        )

set_source_files_properties(${CMAKE_SOURCE_DIR}/adriconf/resources.c PROPERTIES
        GENERATED TRUE
        )

install(TARGETS adriconf DESTINATION bin)

=== PKGBUILD ===
# Maintainer: Balló György <ballogyor+arch at gmail dot com>

pkgname=adriconf
pkgver=2.4.1
pkgrel=2
pkgdesc="GUI tool to configure Mesa drivers by setting options and writing them to the standard drirc file"
arch=(x86_64)
url="https://gitlab.freedesktop.org/mesa/adriconf"
license=(GPL3)
depends=(boost-libs gtkmm3 libxml++ pciutils)
makedepends=(boost cmake)
source=(https://gitlab.freedesktop.org/mesa/$pkgname/-/archive/v$pkgver/$pkgname-v$pkgver.tar.gz)
sha256sums=('a0b6d9c2165cde5a1753fe7885246fbd17e51a768c88bc5b14ab83ac61d869f7')

build() {
  cmake -B build -S $pkgname-v$pkgver \
    -DCMAKE_INSTALL_PREFIX=/usr \
    -DENABLE_UNIT_TESTS=OFF
  cmake --build build
}

package() {
  DESTDIR="$pkgdir" cmake --install build

  install -Dm644 $pkgname-v$pkgver/flatpak/org.freedesktop.adriconf.metainfo.xml \
    "$pkgdir/usr/share/metainfo/org.freedesktop.adriconf.metainfo.xml"
  install -Dm644 $pkgname-v$pkgver/flatpak/org.freedesktop.adriconf.desktop \
    "$pkgdir/usr/share/applications/org.freedesktop.adriconf.desktop"
  install -Dm644 $pkgname-v$pkgver/flatpak/org.freedesktop.adriconf.png \
    "$pkgdir/usr/share/icons/hicolor/256x256/apps/org.freedesktop.adriconf.png"
}
